﻿using System;
using System.Data.SQLite;
using DataAccess.DataTables;
using DataAccess.DataRows;

namespace DataAccess.TableAdapters
{
    public class CurrentStateTableAdapter
    {
        public CurrentStateDataRow FillByAll()
        {
            SQLiteConnection conn = ConnectionProxy.GetConnection();
            CurrentStateDataTable dt = new CurrentStateDataTable();
            bool success = true;

            try
            {
                conn.Open();
                SQLiteCommand selectById = new SQLiteCommand(conn);
                selectById.CommandText = "SELECT * FROM CURRENT_STATE";

                SQLiteDataAdapter da = new SQLiteDataAdapter(selectById);
                da.Fill(dt);
            }
            catch (SQLiteException ex)
            {
                success = false;
            }
            finally
            {
                conn.Close();
            }

            if (!success)
            {
                return null;
            }

            return dt[0];
        }

        public bool InsertCurrentState(int inprogress, int runStartupScript, int currentMessageID)
        {
            SQLiteConnection conn = ConnectionProxy.GetConnection();
            bool success = true;

            try
            {
                conn.Open();
                SQLiteCommand insert = new SQLiteCommand(conn);
                insert.CommandText = "DELETE FROM CURRENT_STATE; INSERT INTO CURRENT_STATE (INPROGRESS, RUN_STARTUP_SCRIPT, CURRENT_MESSAGE_ID) VALUES(" + inprogress + "," + runStartupScript + "," + currentMessageID + ")";

                if (insert.ExecuteNonQuery() < 1)
                {
                    throw new Exception("Error inserting in to CURRENT_STATE table.");
                }
            }
            catch (SQLiteException ex)
            {
                success = false;
            }
            finally
            {
                conn.Close();
            }

            return success;
        }
    }
}