﻿using System;
using System.Data.SQLite;
using DataAccess.DataTables;
using DataAccess.DataRows;

namespace DataAccess.TableAdapters
{
    public class GlucoseTableAdapter
    {
        public GlucoseDataTable FillByAll()
        {
            GlucoseDataTable dt = new GlucoseDataTable();
            SQLiteConnection conn = ConnectionProxy.GetConnection();

            try
            {
                conn.Open();
                SQLiteCommand selectAll = new SQLiteCommand(conn);
                selectAll.CommandText = "SELECT * FROM GLUCOSE";

                SQLiteDataAdapter da = new SQLiteDataAdapter(selectAll);
                da.Fill(dt);
            }
            catch (SQLiteException ex)
            {
                dt = null;
            }
            finally
            {
                conn.Close();
            }

            return dt;
        }

        public bool InsertGlucose(int glucoseLevel, string date, string time)
        {
            SQLiteConnection conn = ConnectionProxy.GetConnection();
            bool success = true;

            try
            {
                conn.Open();
                SQLiteCommand insert = new SQLiteCommand(conn);
                insert.CommandText = "INSERT INTO GLUCOSE (GLUCOSE_LEVEL, DATE, TIME) VALUES(" + glucoseLevel + ",date('" + date + "'),time('" + time + "'))";

                if (insert.ExecuteNonQuery() < 1)
                {
                    throw new Exception("Error inserting in to GLUCOSE table.");
                }
            }
            catch (SQLiteException ex)
            {
                success = false;
            }
            finally
            {
                conn.Close();
            }

            return success;
        }
    }
}