﻿using System;
using System.Data.SQLite;
using DataAccess.DataTables;
using DataAccess.DataRows;

namespace DataAccess.TableAdapters
{
    public class MessageTableAdapter
    {
        public MessageDataRow FillByID(int id)
        {
            SQLiteConnection conn = ConnectionProxy.GetConnection();
            MessageDataTable dt = new MessageDataTable();
            bool success = true;

            try
            {
                conn.Open();
                SQLiteCommand selectById = new SQLiteCommand(conn);
                selectById.CommandText = "SELECT * FROM MESSAGE WHERE ID = " + id;

                SQLiteDataAdapter da = new SQLiteDataAdapter(selectById);
                da.Fill(dt);
            }
            catch (SQLiteException ex)
            {
                success = false;
            }
            finally
            {
                conn.Close();
            }

            if (!success)
            {
                return null;
            }

            return dt[0];
        }

        public MessageDataTable FillByGroupID(int groupID)
        {
            SQLiteConnection conn = ConnectionProxy.GetConnection();
            MessageDataTable dt = new MessageDataTable();

            try
            {
                conn.Open();
                SQLiteCommand selectById = new SQLiteCommand(conn);
                selectById.CommandText = "SELECT * FROM MESSAGE WHERE GROUP_ID = " + groupID;

                SQLiteDataAdapter da = new SQLiteDataAdapter(selectById);
                da.Fill(dt);
            }
            catch (SQLiteException ex)
            {
                dt = null;
            }
            finally
            {
                conn.Close();
            }

            return dt;
        }

        public bool insertMessage(int id, int groupID, string text)
        {
            SQLiteConnection conn = ConnectionProxy.GetConnection();
            bool success = true;

            try
            {
                conn.Open();
                SQLiteCommand insert = new SQLiteCommand(conn);
                insert.CommandText = "INSERT INTO MESSAGE (ID, GROUP_ID, TEXT) VALUES(" + id + "," + groupID + ",'" + text + "')";

                if (insert.ExecuteNonQuery() < 1)
                {
                    throw new Exception("Error inserting into MESSAGE table.");
                }
            }
            catch (SQLiteException ex)
            {
                success = false;
            }
            finally
            {
                conn.Close();
            }

            return success;
        }

        public bool insertMessage(int id, int groupID, string text, string script)
        {
            SQLiteConnection conn = ConnectionProxy.GetConnection();
            bool success = true;

            try
            {
                conn.Open();
                SQLiteCommand insert = new SQLiteCommand(conn);
                insert.CommandText = "INSERT INTO MESSAGE (ID, GROUP_ID, TEXT, SCRIPT) VALUES(" + id + "," + groupID + ",'" + text + "','" + script + "')";

                if (insert.ExecuteNonQuery() < 1)
                {
                    throw new Exception("Error inserting into MESSAGE table.");
                }
            }
            catch (SQLiteException ex)
            {
                success = false;
            }
            finally
            {
                conn.Close();
            }

            return success;
        }
    }
}