/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XSmilAgent
 *
 * The Initial Developer of the Original Code is
 * ITC-irst, TCC Division (http://tcc.fbk.eu) Trento / ITALY.
 * Portions created by the Initial Developer are Copyright (C) 2004 - 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * - Koray Balci (koraybalci@gmail.com)
 * ***** END LICENSE BLOCK ***** */
/*! 
	\file		SMILProcessor.h
	\brief		SMIL-Agent processor.
*/

#pragma once
#ifndef SMILPROCESSOR_H_
#define SMILPROCESSOR_H_

#include "IScriptProcessor.h"

/*!
	\brief SMIL-Agent processor.
	\author Koray Balci

	IScriptProcessor derived class uses SMILManager class to do the processing.
	See SMILManager class for more info.
	\sa SMILManager IScriptProcessor
*/
class SMILProcessor :
	public IScriptProcessor
{
public:
	bool process(const std::string& scriptString, const std::string& filename = "TempFile");
	SMILProcessor(const std::string& name);
	~SMILProcessor(void);
};

#endif // SMILPROCESSOR_H_